<?php /* mycssmenu.php based on mod_mainmenu.class.php,v 1.13 */
/**
* recoded by Konlong
*
*
*	FOUR types of menus : for the CSS minded designer
*
* produces two variable strings in unordered list format - Without
*		<div ...> tags thus allowing the template designer the flexability of use
*
*					$mycssVIRTmenu_content == menus with submenu list
*					$mycssHORZmenu_content == just the top level items of the menu
*
*	produces one un-nested unordered lists with a surrounding division:
*		<div id="navhorzcontainer"> This is for a special applicaion of horizontal menus
*		note this structure is rather unique in that sub-menues are listed in their own unordered list
*		following the primary list as opposed to being enclosed by the primary list.
*
*					$mycssHORZwSUBmenu_content
*
* This last type of menu is a single string similar to the pathway, where the menu items are
*		separated with ' :: '  There is no division specified for this item.
*
*					$mycssPATHmenu_content
*
*
* This file sould be placed in your templates own directory
* & the following should be at the top of your index.php
*
* NOTE: replace 'XXXXXX' with the name of your template
*
* <?php
* defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
* global $mosConfig_absolute_path;
* include($mosConfig_absolute_path."/templates/XXXXXX/mycssmenu.php");
* ?>
*
**/

/* $Id: mod_mainmenu.class.php,v 1.13 2004/01/13 20:36:55 ronbakker Exp $ */
/**
* Menu handling functions
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.13 $
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
if (defined( '_VALID_MYCSSDDMENU' )) return;

/**
* Menu List
*/
	global $database, $my, $cur_template, $Itemid;
	global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_shownoauth;
	
	$menutype = @$params->menutype ? $params->menutype : 'mainmenu';
  $class_sfx = @$params->class_suffix ? $params->class_suffix : '';

	$mycssDropDownmenu_content = "\n".'<div id="menucont">';
	/* If a user has signed in, get their user type */
	$intUserType = 0;
	if($my->gid){
		switch ($my->usertype)
		{
			case 'Super Administrator':
			$intUserType = 0;
			break;
			case 'Administrator':
			$intUserType = 1;
			break;
			case 'Editor':
			$intUserType = 2;
			break;
			case 'Registered':
			$intUserType = 3;
			break;
			case 'Author':
			$intUserType = 4;
			break;
			case 'Publisher':
			$intUserType = 5;
			break;
			case 'Manager':
			$intUserType = 6;
			break;
		}
	}
	else
	{
		/* user isn't logged in so make their usertype 0 */
		$intUserType = 0;
	}
	
	if ($mosConfig_shownoauth) {
		$sql = "SELECT m.* FROM #__menu AS m"
		. "\nWHERE menutype='$menutype' AND published='1'"
		//. "\nAND utaccess >= '$intUserType' "
		. "\nORDER BY parent,ordering";
	} else {
		$sql = "SELECT m.* FROM #__menu AS m"
		. "\nWHERE menutype='$menutype' AND published='1' AND access <= '$my->gid'"
		//. "\nAND utaccess >= '$intUserType' "
		. "\nORDER BY parent,ordering";
	}
	$database->setQuery( $sql	);
	
	$rows = $database->loadObjectList( 'id' );
	echo $database->getErrorMsg();
	
	// establish the hierarchy of the menu
	$children = array();
	// first pass - collect children
	foreach ($rows as $v ) {
		$pt = $v->parent;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push( $list, $v );
		$children[$pt] = $list;
	}
	
	// second pass - collect 'open' menus
	$open = array( $Itemid );
	$count = 20; // maximum levels - to prevent runaway loop
	$id = $Itemid;
	while (--$count) {
		if (isset($rows[$id]) && $rows[$id]->parent > 0) {
			$id = $rows[$id]->parent;
			$open[] = $id;
		} else {
			break;
		}
	}
	
cssDDRecurseMenu( 0, 0, $children, $open, $class_sfx, $mycssDropDownmenu_content);
$mycssDropDownmenu_content .= "</div>";

define( '_VALID_MYCSSDDMENU', true );
/**
* Utility function to recursively work through a hierarchial menu
*/
function cssDDRecurseMenu( $id, $level, &$children, &$open, $class_sfx, &$navDD_cont) {
	global $Itemid;
	if (@$children[$id]) {
		
    if ($level)
		{
			$navDD_cont .= "\n".'<div class="subnavlist">'."\n";
		}
		foreach ($children[$id] as $row) {
			if (!$level)
			{
				$navDD_cont .= "\n".'<div class="navlist"'."\n".'onmouseover="this.className=\'display\'"'."\n".'onmouseout="this.className=\'navlist\'">';
			}
			
			$idclass = '';
			$navDD_cont .= "\n".cssDDGetMenuLink( $row, $level, 1, $class_sfx, $idclass)."\n";
			
			//if (in_array( $row->id, $open )) {
				cssDDRecurseMenu( $row->id, $level+1, $children, $open, $class_sfx, $navDD_cont);
		//	}
			if (!$level)
			{
				$navDD_cont .= "\n".'</div>';
			}
		}
		$navDD_cont .= "\n</div>";
	}
}

/**
* Utility function for writing a menu link
*/
function cssDDGetMenuLink( $mitem, $level=0, $DD, $class_sfx='', $idclass='') {
	global $Itemid, $mosConfig_live_site;
	$txt = '';
	
	switch ($mitem->type) {
		case 'separator';
		// do nothing
		break;
		
		case 'url':
		if (eregi( "index.php\?", $mitem->link )) {
			//$mitem->link .= "&Returnid=$Itemid";
			if (!eregi( "Itemid=", $mitem->link )) {
				$mitem->link .= "&Itemid=$mitem->id";
			}
		}
		break;
		
		default:
		$mitem->link .= "&Itemid=$mitem->id";
		break;
	}
	
	$mitem->link = str_replace( '&', '&amp;', $mitem->link );
	
	if (strcasecmp(substr($mitem->link,0,4),"http")) {
		$mitem->link = sefRelToAbs($mitem->link);
	}
	
	$menuclass = "images";
	if ($DD)
	{
		$menuclass = "navlinks";
		if ($level > 0) {
			$menuclass = "subnavlinks";
		}
	}
	switch ($mitem->browserNav) {
		// cases are slightly different
		case 1:
		// open in a new window
		$txt = "<a href=\"$mitem->link\" target=\"_window\" class=\"$menuclass\" $idclass>$mitem->name</a>";
		break;
		
		case 2:
		// open in a popup window
		$txt = "<a href=\"#\" onClick=\"javascript: window.open('$mitem->link', '', 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=780,height=550'); return false\" class=\"$menuclass\" $idclass>$mitem->name</a>";
		break;
		
		case 3:
		// don't link it
		$txt = "<span class=\"$menuclass\" $idclass>$mitem->name</span>";
		break;
		
		default:	// formerly case 2
		// open in parent window
		$txt = "<a href=\"$mitem->link\" class=\"$menuclass\" $idclass>$mitem->name</a>";
		break;
	}
	
	return $txt;
}
?>
